﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Text;

namespace Export_WebGrid_CSV_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            NorthwindEntities entities = new NorthwindEntities();
            return View(from customer in entities.Customers.Take(10)
                        select customer);
        }

        [HttpPost]
        public FileResult Export()
        {
            NorthwindEntities entities = new NorthwindEntities();
            List<object> customers = (from customer in entities.Customers.ToList().Take(10)
                                      select new[] { customer.CustomerID.ToString(), 
                                                                customer.ContactName, 
                                                                customer.City, 
                                                                customer.Country
                                  }).ToList<object>();

            //Insert the Column Names.
            customers.Insert(0, new string[4] { "Customer ID", "Customer Name", "City", "Country" });

            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < customers.Count; i++)
            {
                string[] customer = (string[])customers[i];
                for (int j = 0; j < customer.Length; j++)
                {
                    //Append data with separator.
                    sb.Append(customer[j] + ',');
                }

                //Append new line character.
                sb.Append("\r\n");

            }

            return File(Encoding.ASCII.GetBytes(sb.ToString()), "text/csv", "Grid.csv");
        }
    }
}